import config
import numpy as np
import networkx as nx
import utils


def main():
    x = []
    y = []
    for i, data in enumerate(config.datasets):
        filename = 'data/' + data + config.extension
        print('Reading dataset from: ' + filename)
        graph = nx.read_edgelist(filename)
        count = 0
        while count < config.num_sg:
            # Get subgraph from random walk
            raw_adj = utils.sample_random_walk(graph, config.subgraph_size)
            # Check if it has the required number of nodes
            if nx.number_of_nodes(raw_adj) != config.subgraph_size:
                continue
            # Append to the data file. Comma is imoprtant
            x += utils.get_adj(raw_adj),
            y += i,
            count += 1
            if count % 100 == 0:
                print(str(count) + ' subgraphs from ' + filename + 'collected')
    x = np.stack(x, axis=0)
    y = np.stack(y, axis=0)
    # Save the data and labels
    np.save(config.datafile, x)
    np.save(config.labels, y)


if __name__ == '__main__':
    main()
