# ReadMe

This package uses the novel structured image embedding feature to perform subgraph classification.  Given a subgraph, you can predict its parent network. Please see the cited papers for more details.

# Usage:
`cd subgraph-classification`

`python driver.py`

# Config:
- Set the parameters as required in the `config.py` file and then run `driver.py` as shown above.

# Citations:
- Hegde, K., Magdon-Ismail, M., Ramanathan, R., & Thapa, B. (2018). Network Signatures from Image Representation of Adjacency Matrices: Deep/Transfer Learning for Subgraph Classification. arXiv preprint arXiv:1804.06275.
- Wu, Ke, Philip Watters, and Malik Magdon-Ismail. "Network classification using adjacency matrix embeddings and deep learning." Advances in Social Networks Analysis and Mining (ASONAM), 2016 IEEE/ACM International Conference on. IEEE, 2016.

# Datasets:
- [Facebook](https://snap.stanford.edu/data/egonets-Facebook.html)
- J. McAuley and J. Leskovec. Learning to Discover Social Circles in Ego Networks. NIPS, 2012.
- [Road Network](https://snap.stanford.edu/data/roadNet-PA.html)
- J. Leskovec, K. Lang, A. Dasgupta, M. Mahoney. Community Structure in Large Networks: Natural Cluster Sizes and the Absence of Large Well-Defined Clusters. Internet Mathematics 6(1) 29--123, 2009.

# Other Algorithms:
- [Stacked de-noising Autoencoder](http://www.cs.rpi.edu/~magdon/LFDlabpublic.html/software.html) - Wu, Ke, and Malik Magdon-Ismail. "Node-by-node greedy deep learning for interpretable features." arXiv preprint arXiv:1602.06183 (2016).
- [Diffusion Convolutional Neural Network](https://github.com/jcatw/dcnn) - Atwood, James, and Don Towsley. "Diffusion-convolutional neural networks." Advances in Neural Information Processing Systems. 2016.
- [Graph Kernels](https://github.com/BorgwardtLab/GraphKernels) - Shervashidze, Nino, Pascal Schweitzer, Erik Jan van Leeuwen, Kurt Mehlhorn, and Karsten M. Borgwardt. "Weisfeiler-lehman graph kernels." Journal of Machine Learning Research 12, no. Sep (2011): 2539-2561.